#ifndef plugin_timerH
#define plugin_timerH

#include "plugin_struct.h"

#define TLEN_TIMER_CALLFUNCTION          "Tlen/Timer/CallFunction"

#define TLEN_TIMER_CREATE               1
#define TLEN_TIMER_START                2
#define TLEN_TIMER_STOP                 3
#define TLEN_TIMER_KILL                 4

typedef struct {

 int structSize;		//wielko struktury w bajtach

 HANDLE TimerHandle;
 char *TimerID;         //Unikalny ID, ktry przypisujemy zapytaniu, eby je rozpozna pniej atwo

 unsigned int FireCount; // ilosc wywolan timera, 0 dla nieskonczenie wiele
 unsigned int Interval; // odstep czasu miedzy wywolaniami w ms

 int Flags;

 TLENFUNCTION CallBackFunc;
 char *CallBackFuncName;

 void *OwnerData;

} TimerDef;

#define TLEN_TIMER_FLAG_STARTAFTERCREATION      0x0001 //odpala timer zaraz po stworzeniu
#define TLEN_TIMER_FLAG_AUTODESTROY             0x0002 //niszczy timer, gdy ten zostal ustawiony na konkretna ilosc odpalen


#define TLEN_TIMER_EVENT_FIRED          1
#define TLEN_TIMER_EVENT_DESTROYED      2


#define TLEN_TIMERID_MINIMIZE   "Tlen/TimerID/Minimize"
#define TLEN_TIMERID_EVENTS     "Tlen/TimerID/Events"
#define TLEN_TIMERID_PROGRESS   "Tlen/TimerID/Progress"
#define TLEN_TIMERID_CHATPICKER "Tlen/TimerID/ChatPicker"
#define TLEN_TIMERID_TLENICON   "Tlen/TimerID/TlenIcon"
#define TLEN_TIMERID_GGICON     "Tlen/TimerID/GGIcon"

#endif

/* przyklad

callback:

static int TimerCallback(WPARAM wParam, LPARAM lParam)
{
 if (wParam == TLEN_TIMER_EVENT_FIRED)
 {
   zostal uruchomiony timer...
 }

 return 0;
}


tworzenie timera

 TimerDef tdef;
 InitializeStruct(tdef);
 tdef.Interval = 500;
 tdef.FireCount = 1;
 tdef.CallBackFunc = TimerCallback;
 tdef.TimerID = "jakis identyfikator";
 tlen_functions->CallTlenFunction(hInst, TLEN_TIMER_CALLFUNCTION, (WPARAM) TLEN_TIMER_CREATE, (LPARAM) &tdef);


niszczenie timera

 TimerDef tdef;
 InitializeStruct(tdef);
 tdef.TimerID = "jakis identyfikator";
 tlen_functions->CallTlenFunction(hInst, TLEN_TIMER_CALLFUNCTION, (WPARAM) TLEN_TIMER_KILL, (LPARAM) &tdef);

*/
